
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng.h"
#define _GNU_SOURCE
#include <stdio.h>
#include <alloca.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <assert.h>
#include <sys/types.h>
#include <dirent.h>                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                /*#include <dirent.h> */     /* opendir() closedir() */

#include "../../src/initng_string_tools.h"
#include "../../src/initng_service_cache.h"
#include "../../src/initng_global.h"
#include "../../src/initng_open_read_close.h"
#include "../../src/initng_toolbox.h"
#include "../../src/initng_plugin_hook.h"
#include "../../src/initng_plugin_callers.h"
#include "../../src/initng_common.h"

#include "initng_find.h"


/* Load a service from a process_name or process_path */
service_h *initng_find(char *service)
{
    /* means that it may not be a direct service request, then we start looking in subfolders */

    service_h *tmp = NULL;
    DIR *path;
    struct dirent *dir_e;
    char t[20];

    assert(service);

    path = opendir(INITNG_ROOT "/system");
    while ((dir_e = readdir(path)))
    {
        if (strstr(dir_e->d_name, service))
        {
            strcpy(t, "system/");
            strcat(t, service);
            W_("Service shud be system/%s\n", service);
            if ((tmp = parse_service(t)))
                return (tmp);

        }

    }
    closedir(path);

    path = opendir(INITNG_ROOT "/daemon");
    while ((dir_e = readdir(path)))
    {
        if (strstr(dir_e->d_name, service))
        {
            strcpy(t, "daemon/");
            strcat(t, service);
            W_("Service shud be daemon/%s\n", service);

            if ((tmp = parse_service(t)))
                return (tmp);
        }
    }
    closedir(path);

    return (NULL);
}

int module_init(const char *version)
{

    D_("module_init();\n");
    if (strcmp(version, INITNG_VERSION) != 0)
    {
        F_("This module, is compiled for \"%s\" version, and initng is compiled on \"%s\" version, wont load this module!\n", INITNG_VERSION, version);
        return (FALSE);
    }

    return (initng_add_hook(PARSERS, 70, &initng_find));

}

void module_unload(void)
{
    D_("module_unload();\n");
    initng_del_hook(PARSERS, &initng_find);
}
