/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "initng.h"
#define _GNU_SOURCE
#include <assert.h>
#include <stdlib.h>
#include <string.h>

#include "initng_control_command.h"

#include "initng_global.h"
#include "initng_toolbox.h"

/* this adds a command to the global command struct */
int initng_command_add(s_command * cmd)
{
    s_command *current = NULL;

    assert(cmd);

    /* look for duplets */
    while_command_db(current)
    {
        if (current == cmd || current->command_id == cmd->command_id)
        {
            F_("Cant add command: %c, %s, it exists alredy!\n",
               current->command_id, current->description);
            return (FALSE);
        }
    }

    /* add this command to list */
    list_add(&cmd->list, &g.command_db.list);
    return (TRUE);
}

void initng_command_free_all(void)
{
    s_command *current, *safe = NULL;

    while_command_db_safe(current, safe)
    {
        initng_command_del(current);
    }
}

/* look for a command by command_id */
s_command *initng_command_find_by_command_id(char cid)
{
    s_command *current = NULL;

    while_command_db(current)
    {
        if (current->command_id == cid)
            return (current);
    }
    return (NULL);
}

/* look for a command by command_id */
s_command *initng_command_find_by_command_string(char *name)
{
    s_command *current = NULL;

    while_command_db(current)
    {
        if (current->long_id && strcmp(current->long_id, name) == 0)
            return (current);
    }
    return (NULL);
}
