
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef STRING_TOOLS_H
#define STRING_TOOLS_H


/*
 * MACRO JUMP_SPACES, will increase string, until it founds a valid token.
 */

#define JUMP_SPACES(s) while ((s)[0] == ' ' || (s)[0] == '\t' || (s)[0] == '=') (s)++;

/*
 * MACRO JUMP_TO_NEXT_ROW, will increase string, until it hits a new row token.
 * and after that also jump the new row token.
 */

#define JUMP_TO_NEXT_ROW(s) \
    while((s)[0] != '\0' && (s)[0] != '\n' && (s)[0] != ';') \
	(s)++; \
    if((s)[0]!='\0') (s)++;


char **split_n(char *buf, int *len, int plus, int ofs);
int chars_to_end_of_this_stack(const char *string);
int st_cmp(char **string, const char *to_cmp);
char *st_dup_next_word(char **string);
char *st_dup_line(char **string);
char *st_strip_path(char *string);
int st_strip_end(char **string);
char *st_get_path(char *string);

/* pattern searching */
int service_match(const char *string, const char *pattern);

#endif
